#define	NOCCARGC

#asm
	ASEG
	ORG	83D0H
#endasm

char	usrsp;		/* 0x83d0 top of user stack */

char	rst2[3];	/* 0x83d1 RST 2 vector */
char	rst3[3];	/* 0x83d4 RST 3 vector */
char	rst4[3];	/* 0x83d7 RST 4 vector */
char	rst5[3];	/* 0x83dA RST 5 vector */
char	rst6[3];	/* 0x83dD RST 6 vector */

int	regpc;		/* 0x83e0 save area of PC regiter */
int	regsp;		/* 0x83e2 save area of SP regiter */
int	reghl;		/* 0x83e4 save area of HL regiter */
int	regde;		/* 0x83e6 save area of DE regiter */
int	regbc;		/* 0x83e8 save area of BC regiter */
int	regpsw;		/* 0x83eA save area of Accumlator & status flag */

int	datareg;	/* 0x83ec data register */
char	*addrreg;	/* 0x83ee address register */

#asm
	ORG	83ECH
#endasm

char	data_l;		/* 0x83ec data register low */
char	data_h;		/* 0x83ed data register high */
char	addr_l;		/* 0x83ee address register low */
char	addr_h;		/* 0x83ef address register high */

int	brkadr;		/* 0x83f0 break address */
char	brkcnt;		/* 0x83f2 break counter */

char	keyflg;		/* 0x83f3 if keyboard is pressed */

char	work1;		/* 0x83f4 1st byte of LED display */
char	work2;		/* 0x83f5 2nd byte of LED display */
char	work3;		/* 0x83f6 3rd byte of LED display */
char	work4;		/* 0x83f7 4th byte of LED display */

char	dig1;		/* 0x83f8 1st digit LED segment data */
char	dig2;		/* 0x83f9 2nd digit LED segment data */
char	dig3;		/* 0x83fa 3rd digit LED segment data */
char	dig4;		/* 0x83fb 4th digit LED segment data */
char	dig5;		/* 0x83fc 5th digit LED segment data */
char	dig6;		/* 0x83fd 6th digit LED segment data */
char	dig7;		/* 0x83fe 7th digit LED segment data */
char	dig8;		/* 0x83ff 8th digit LED segment data */

#asm
	ORG	83F8H
#endasm

int	dig12;		/* 0x83f8 1st & 2nd digit LED segment data */
int	dig34;		/* 0x83fa 3rd & 4th digit LED segment data */
int	dig56;		/* 0x83fc 5th & 5th digit LED segment data */
int	dig78;		/* 0x83fe 7th & 8th digit LED segment data */

int	t125us;		/* 0x8400 125uS Timer Subroutine Pointer Address */

char	statck1[126];
int	monsp;		/* 0x8480 top of monitor stack */
char	statck2[126];
int	subsp;		/* 0x8500 top of subroutine stack */

#asm
	CSEG
#endasm

/********************************************************
 * Definition of constants				*
 ********************************************************/

#define initreg	0x83ec	/* register save area */
#define initlen	0x0c	/* length of register area */

#define	led0	0x5c	/* Segment Value of "0" */
#define	led1	0x06	/* Segment Value of "1" */
#define	led2	0x5b	/* Segment Value of "2" */
#define	led3	0x4f	/* Segment Value of "3" */
#define	led4	0x66	/* Segment Value of "4" */
#define	led5	0x6d	/* Segment Value of "5" */
#define	led6	0x7d	/* Segment Value of "6" */
#define	led7	0x27	/* Segment Value of "7" */
#define	led8	0x7f	/* Segment Value of "8" */
#define	led9	0x6f	/* Segment Value of "9" */
#define	leda	0x77	/* Segment Value of "A" */
#define	ledb	0x7c	/* Segment Value of "B" */
#define	ledc	0x39	/* Segment Value of "C" */
#define	ledd	0x5e	/* Segment Value of "D" */
#define	lede	0x79	/* Segment Value of "E" */
#define	ledf	0x71	/* Segment Value of "F" */

#define	led0l	0x3f	/* Segment Value of "0" */
#define	led2p	0xdb	/* Segment Value of "2." */
#define	led3p	0xcf	/* Segment Value of "3." */
#define	led4p	0xe6	/* Segment Value of "4." */
#define	led5p	0xed	/* Segment Value of "5." */
#define	led_	0x40	/* Segment Value of "-" */
#define	ledxp	0x80	/* Segment Value of "." */

#define init_cw	0x92	/* set mode0, port a:in, b:in, c0-3:in, c4-7:out */

#define	k_0	0x00	/* 0 key */
#define	k_1	0x01	/* 1 key */
#define	k_2	0x02	/* 2 key */
#define	k_3	0x03	/* 3 key */
#define	k_4	0x04	/* 4 key */
#define	k_5	0x05	/* 5 key */
#define	k_6	0x06	/* 6 key */
#define	k_7	0x07	/* 7 key */
#define	k_8	0x08	/* 8 key */
#define	k_9	0x09	/* 9 key */
#define	k_a	0x0a	/* A key */
#define	k_b	0x0b	/* B key */
#define	k_c	0x0c	/* C key */
#define	k_d	0x0d	/* D key */
#define	k_e	0x0e	/* E key */
#define	k_f	0x0f	/* F key */
#define	k_g	0x00	/* G key */
#define	k_h	0x01	/* H key */
#define	k_i	0x02	/* I key */
#define	k_j	0x03	/* J key */
#define	k_k	0x15	/* K key */
#define	k_l	0x04	/* L key */
#define	k_m	0x05	/* M key */
#define	k_n	0x06	/* N key */
#define	k_o	0x07	/* O key */
#define	k_p	0x13	/* P key */
#define	k_q	0x08	/* Q key */
#define	k_r	0x09	/* R key */
#define	k_s	0x0a	/* S key */
#define	k_t	0x0b	/* T key */
#define	k_u	0x14	/* U key */
#define	k_v	0x0c	/* V key */
#define	k_w	0x0d	/* W key */
#define	k_x	0x0e	/* X key */
#define	k_y	0x0f	/* Y key */
#define	k_z	0x12	/* Z key */
#define	k_sp	0x17	/* " " (LOAD DATA) key */
#define	k_run	0x10	/* RUN key */
#define	k_ret	0x11	/* RET key */
#define	k_as	0x12	/* ADRS SET key */
#define	k_rdd	0x13	/* READ DECR key */
#define	k_rdi	0x14	/* READ INCR key */
#define	k_wri	0x15	/* WRITE INCR key */
#define	k_sd	0x16	/* STORE DATA key */
#define	k_ld	0x17	/* LOAD DATA key */

#asm

MONSP	EQU	8480H	; monitor stack area (originally 83D0H)
SUBSP	EQU	8500H	; subroutine stack area
USRSP	EQU	83D0H	; user stack area (originally 83C6H)

PPIPA	EQU	0F8H	; PPI 8255 Port-A Register I/O Address
PPIPB	EQU	0F9H	; PPI 8255 Port-B Register I/O Address
PPIPC	EQU	0FAH	; PPI 8255 Port-C Register I/O Address
PPICW	EQU	0FBH	; PPI 8255 Control Word

LEDA	EQU	77H	; Segment Value of "A"
LEDB	EQU	7CH	; Segment Value of "B"
LEDC	EQU	39H	; Segment Value of "C"
LEDD	EQU	5EH	; Segment Value of "D"
LEDE	EQU	79H	; Segment Value of "E"
LEDH	EQU	76H	; Segment Value of "H"
LEDL	EQU	38H	; Segment Value of "L"
LEDP	EQU	73H	; Segment Value of "P"
LEDS	EQU	6DH	; Segment Value of "S"

#endasm

/********************************************************
 * PPI I/O function					*
 ********************************************************/

char inppa()	/* input PPI port A */
{
#asm
	IN	PPIPA
	MOV	L,A
	MVI	H,0
#endasm
}

char inppb()	/* input PPI port B */
{
#asm
	IN	PPIPB
	MOV	L,A
	MVI	H,0
#endasm
}

void outppc(char n)	/* input PPI port C */
{
#asm
	POP	D
	POP	H
	MOV	A,L
	OUT	PPIPC
	PUSH	H
	PUSH	D
#endasm
}

void outpcw(char n)	/* input PPI control word */
{
#asm
	POP	D
	POP	H
	MOV	A,L
	OUT	PPICW
	PUSH	H
	PUSH	D
#endasm
}

/********************************************************
 * Definition of standard function			*
 ********************************************************/

void memset(char *p, char v, int n)
{
  for(; n; n--) {
    *p++ = v;
  }
}

void memcpy(char *d, char *s, int n)
{
  if(d > s) {
    d += n; s += n;
    for(; n; n--) {
      *--d = *--s;
    }
  } else for(; n; n--) {
    *d++ = *s++;
  }
}

int strlen(char *p)
{ int n;
  n = 0;
  while(*p++) n++;
  return n;
}

int strcmp(char *s1, char *s2)
{
  while(*s1 == *s2) {
    if(!*s1) return 0;
    s1++; s2++;
  }
  return 1;
}

/********************************************************
 * RESET and INT entery and monitor main loop		*
 ********************************************************/

reset()		/* reset routine */
{
  memset(initreg, 0, initlen);	/* clear register area */
  regsp = &usrsp;		/* assign user stack */
  outpcw(init_cw);		/* set mode0, port a:in, b:in, c0-3:in, c4-7:out */
  dsp_cpu();			/* check CPU and display on LED */
  outppc(0xff);			/* initialize port c */
  goto monitor;

		/* break(interrupt) routine */
#asm
BREAK::	SHLD	REGHL		; save HL register
	POP	H
	SHLD	REGPC		; save PC register
	PUSH	PSW
	LXI	H,2
	DAD	SP
	SHLD	REGSP		; save SP register
	POP	H
	SHLD	REGPSW		; save PSW register
	XCHG
	SHLD	REGDE		; save DE register
	PUSH	B
	POP	H
	SHLD	REGBC		; save BC register
	LXI	SP,MONSP	; assign SP register
#endasm

  if(brkcnt) {
    if(brkcnt == -1) {			/* if break count = 0xff */
      if(rd_key() == -1) delay(18);	/* if no keys pressed, wait 0.5 second */
      else brkcnt = 0;			/* if key pressed, force to break at next instruction */
    }
    if(regpc == brkadr) brkcnt--;	/* decremect break count at break address */
    addrreg = regpc;		/* address register <- PC */
    datareg = regpsw;		/* data register <- PSW */
    dsp_reg();
    goto ret;
  }
  addrreg = regpc;		/* address register <- PC */
  datareg = regpsw;		/* data register <- PSW */
  dsp_reg();

#asm
monitor::
#endasm
monitor:	/* monitor routine */
  command();

		/* return to user program */
ret:
#asm
	LHLD	REGPSW
	PUSH	H
	POP	PSW		; restore PSW register
	LHLD	REGBC
	PUSH	H
	POP	B		; restore BC register
	LHLD	REGDE
	XCHG			; restore DE register
	LHLD	REGSP
	SPHL			; restore SP register
	LHLD	REGPC
	PUSH	H		; restore PC into top of stack
	LHLD	REGHL		; restore HL register
	EI			; enable interrupt
#endasm
}

/********************************************************
 * Usefull subroutines					*
 ********************************************************/

char seg[] = { led0, led1, led2, led3, led4, led5, led6, led7,
               led8, led9, leda, ledb, ledc, ledd, lede, ledf };

void dsp_led()	/* display LED from WORD1-WORD4 */
{ char *w, *s;
  s = &dig1;
  for(w = &work1; w != &work4 + 1; w++) {
    *s++ = seg[(*w >> 4) & 0x0f];
    *s++ = seg[ *w & 0x0f];
  }
}

void dsp_reg()	/* display address & data register */
{
  work1 = addr_h;
  work2 = addr_l;
  work3 = data_h;
  work4 = data_l;
  dsp_led();
}

char scan_key()	/* scan key matrix */
{ char n, k, l;
  for(n = 0; n < 3; n++) {
    outppc(~(0x10 << n));	/* enable key scan line */
    k = inppa();		/* read key matrix */
    if(k != -1) {
      n <<= 3;			/* set offset of each key line */
      l = 0x01;
      k = ~k;
      while(!(k & l)) {		/* count until key pressed */
        l <<=1;
        n++;
      }
      k = n;
      break;
    }
  }
  return k;
}

char rd_key()	/* read key */
{ char k;
  k = scan_key();
  while(k != -1) {	/* eliminate chattering */
    delay2();
    k = scan_key();
    if((k != -1) && (!keyflg)) {
      keyflg = -1;		/* set key flag */
      break;
    }
  }
  if(k == -1) keyflg = 0;	/* reset key flag */
  return k;
}

char key_in()	/* wait for key input */
{ char k;
  while(1) {
    k = rd_key();
    if(keyflg) break; /* key flag == true */
  }
  return k;
}

void ser_out(char n)	/* output 8 bit to serial line */
{ char i;
  outppc(0);		/* write start bit */
  delay2();		/* 1 bit timer */
  for(i = 0; i < 8;  i++) {	/* write 8 data bit */
    outppc(n & 0x01);
    n >>= 1;
    delay2();		/* 1 bit timer */
  }
  outppc(1);		/* write stop bit */
  delay3();		/* 3 bit timer */
}

char ser_in()	/* input 8 bit from serial line */
{ char i, n;
  n = 0;
  outppc(0);		/* disable DMA(LED display) */
  while(1) {
    while(inppb() & 0x01);	/* wait for start bit */ 
    delay1();			/* 1/2 bit timer */
    if(!(inppb() & 0x01)) break;/* make sure start bit again */ 
  }
  delay2();		/* 1 bit timer */
  for(i = 0; i < 8; i++) {	/* read 8 data bit */
    n += (inppb() & 0x01) << i;
    delay2();			/* 1 bit timer */
  }
  delay2();		/* 1 bit timer */
  return n;
}

/********************************************************
 * Timer function for 8080/8085				*
 ********************************************************/

void d125us()	/* 125uS Timer */
{
#asm
WAIT:	PUSH	H	; save HL register
	LHLD 	T125US
	PCHL		; jump T125US indirect
TLOOP:	DCR	D
	JNZ	WAIT
#endasm
}

void d80_1w()	/* 8080 2MHz(18.432MHz X'tal) 1Wait 125uS Timer(TK-80 Original Setting) */
{
#asm			; 9,225 clock
	POP	H
	MVI	E,08H
	MVI	E,08H
	DCR	E
	JNZ	$-1
	JMP	TLOOP
#endasm
}

void d80_0w()	/* 8080 2MHz(18MHz X'tal) 125uS Timer */
{
#asm			; 9,238 clock
	POP	H
	NOP	
	MVI	E,0BH
	MVI	E,0BH
	DCR	E
	JNZ	$-1
	JMP	TLOOP
#endasm
}

void d80_3m()	/* 8080 3MHz(27MHz X'tal) 125uS Timer */
{
#asm			; 13,517 clock
	POP	H
	NOP	
	NOP	
	NOP	
	NOP	
	MVI	E,13H
	DCR	E
	JNZ	$-1
	JMP	TLOOP
#endasm
}

void d85_2m()	/* 8085 2MHz 125uS Timer */
{
#asm			; 9,089 clock
	POP	H
	NOP	
	NOP	
	NOP	
	NOP	
	MVI	E,0BH
	MVI	E,0BH
	DCR	E
	JNZ	$-1
	JMP	TLOOP
#endasm
}

void d85_3m()	/* 8085 3MHz 125uS Timer */
{
#asm			; 13,517 clock
	POP	H
	NOP	
	NOP	
	NOP	
	NOP	
	NOP	
	MVI	E,14H
	DCR	E
	JNZ	$-1
	JMP	TLOOP
#endasm
}

void d85_4m()	/* 8085 4MHz 125uS Timer */
{
#asm			; 18,017 clock
	POP	H
	NOP	
	NOP	
	NOP	
	MVI	E,1DH
	MVI	E,1DH
	DCR	E
	JNZ	$-1
	JMP	TLOOP	
#endasm
}

void d85_5m()	/* 8085 5MHz 125uS Timer */
{
#asm			; 22,553 clock
	POP	H
	NOP	
	NOP	
	NOP	
	MVI	E,26H
	MVI	E,26H
	DCR	E
	JNZ	$-1
	JMP	TLOOP	
#endasm
}

void delay1()	/* delay 36 x 125uS */
{
#asm
	MVI	D,36
	JMP	D125US
#endasm
}

void delay2()	/* delay 4.5mS (72 x 125uS) */
{
#asm
	MVI	D,72
	JMP	D125US
#endasm
}

void delay3()	/* delay 9mS (216 x 125uS) */
{
#asm
	MVI	D,216
	JMP	D125US
#endasm
}

void delay(char n)	/* delay 27*n mS (216 x 125uS) */
{
for(; n > 0; n--) delay3();	/* wait for 3 sec */
}

/********************************************************
 * Monitor Command Processor				*
 *							*
 * New 3 features are added than original TK-80.	*
 *							*
 * 1) Assembler						*
 *  Press <ADRS SET> key twice then the prompt (decimal	*
 *  point at last digit of address) is appeared.	*
 *  When error for input, "...." displayed, but you can	*
 *  continue correct code again.			*
 *							*
 * Following key overlay is needed to input alphabet.	* 
 *  C D E F <ADRS SET>   --> V W X Y Z			*
 *  8 9 A B <READ INCR>  --> Q R S T U			*
 *  4 5 6 7 <READ DECR>  --> L M N O P			*
 *  0 1 2 3 <WRITE INCR> --> G H I J K			*
 * Also, <sp> overlay key assigned on <LOAD DATA> key.	* 
 *							*
 *  format(1): <opcode><sp>				*
 *  format(2): <opcode><sp><register operand>		*
 *  format(3): <opcode><sp><data address perand><sp>	*
 * where "," separator is not necessay in operand.	*
 * Press <sp> without opcode, then exit assembler.	*
 *							*
 * 2) Verify & modify registers just after break	*
 *  Just after break stop, press <READ INCR> key	*
 *  HL register displayed,				*
 *  press <READ INCR> key AC register displayed.	*
 *  Then <READ INCR> or <READ DECR> key	for up/down.	*
 *							*
 *  Program Counter       "PC"				*
 *  Stack Pointer         "SP"				*
 *  HL register           "HL" <-- <READ INCR> key	*
 *  DE register           "DE"				*
 *  BC register           "BC"				*
 *  Processor Status word "PS"				*
 *  Break Address         "BA"				*
 *  break Address Counter "AC" <-- <READ DECR> key	*
 *							*
 * 3) Auto Trace feature				*
 *  When break counter equals 0xff, monitor execute	*
 *  a instruction in 0.5 second slowly.			*
 *  Pressing any monitor key make its execution stop.	*
 ********************************************************/


char serr[]   = { lede, ledxp, ledxp, ledxp };		/* "E..."  */
char serr2[]  = { ledxp,  ledxp, ledxp, ledxp };	/* "...."  */

error()	/* display error */
{
  memcpy(&dig1, serr, 8);	/* copy "E... ...." to segment memory */
}

error2()	/* display error */
{
  memcpy(&dig5, serr2, 4);	/* copy "xxxx ...." to segment memory */
}

int regname[19];		/* register name at instruction break */ 

#asm
	ORG	$-38
	DB	ledp, ledc	; "PC"
	DW	0
	DB	leds, ledp	; "SP"
	DW	0
	DB	ledh, ledl	; "HL"
	DW	0
	DB	ledd, lede	; "DE"
	DW	0
	DB	ledb, ledc	; "BC"
	DW	0
	DB	ledp, leds	; "PS"
	DW	0, 0, 0, 0, 0
	DB	ledb, leda	; "BA"
	DW	0
	DB	leda, ledc	; "AC"
#endasm

int rname(char *i)	/* identify special address name */
{ int r;
  r = i - &regpc;	/* i must be pointer */
  if((r >= 0) && (r < 0x13)) return regname[r];
  return -1;
}

void adr_data()	/* display address & data register */
{ char *p;
  if(((p = rname(addrreg)) != 0) && (p != -1)) {
    dig12 = 0; dig34 = p;	/* display register name */
    p = &dig5;
    *p++ = seg[(data_h >> 4) & 0x0f];
    *p++ = seg[ data_h & 0x0f];
    *p++ = seg[(data_l >> 4) & 0x0f];
    *p   = seg[ data_l & 0x0f];
  } else dsp_reg();
}

void sft_data(char n)	/* shift data register by 0-F key */
{
  datareg <<= 4; datareg += n & 0x0f;
}

void run()	/* RUN key: ADRS --> PC, return to user program */
{
  regpc = addrreg;
}

void rd_mem()	/* read memory after ADRS SET key */
{
  if(rname(addrreg) == -1) {
    data_h = data_l;
    data_l = *addrreg;
  } else if(addrreg == &brkcnt) {
    data_h = 0;
    data_l = *addrreg;
  } else {
    data_l = *addrreg; data_h = *(addrreg + 1);
  }
}

void wr_mem()	/* write memory after WRITE INCR key */
{
  if((rname(addrreg) == -1) || (addrreg == &brkcnt)) {
    *addrreg = data_l;
  } else {
    *addrreg = data_l; *(addrreg + 1) = data_h;
  }
}

void set_adr()	/* set address register by ADRS SET key */
{
  addrreg = datareg; rd_mem();
}

void upd_addr(char n)	/* updating address register */
{ int p;
  if(rname(addrreg) == -1) addrreg += n;	/* normal update */
  else {					/* register save area */
    while((p = rname(addrreg + n)) == 0) addrreg += n;	/* skip if hidden address */
    if(p == -1) {
      if(n < 0) addrreg += 0x12; else addrreg -= 0x12;	/* round up/down */
    } else addrreg += n;			/* next register */
  }
}

void rd_dec()	/* READ DECR key */
{
  upd_addr(-1);
  rd_mem();
}

void rd_inc()	/* READ INCR key */
{
  upd_addr(1);
  rd_mem();
}

void wr_inc()	/* WRITE INCR key */
{
  wr_mem();
  upd_addr(1);
  rd_mem();
}

void st_tape()	/* STORE DATA key */
{ char s, *p;
  int e;
  s = 0;
  p = addrreg;
  ser_out(p >> 8); s += p >> 8; /* output start address */
  ser_out(p);      s += p; 
  e = datareg;
  ser_out(e >> 8); s += e >> 8; /* output end address */
  ser_out(e);      s += e; 
  for(; p != datareg; p++) { 	/* output data */
    ser_out(*p); s += *p;
  }
  ser_out(s);		/* output checksum */
}

char ld_tape()	/* LOAD DATA key */
{ char d, s, *p;
  int e;
  s = 0;
  d = ser_in(); s += d;	/* input start address */
  p = d;
  d = ser_in(); s += d;
  p = (p << 8) + (d & 0xff);
  addrreg = p;
  d = ser_in(); s += d;	/* input end address */
  e = d;
  d = ser_in(); s += d;
  e = (e << 8) + (d & 0xff);
  datareg = e;
  for(; p != e; p++) { 	/* input data */
    d = ser_in(); s += d;
    *p = d;
  }
  d = ser_in();		/* input checksum */
  return (d != s);
}

command()	/* monitor command processor */
{ char b, k, last;
  int p;
  b = 1;
  last = -1;
  adr_data();
  while(b) {
    outpcw(init_cw);		/* set mode0, port a:in, b:in, c0-3:in, c4-7:out */
    outppc(0xff);		/* initialize port c */
    switch(k = key_in()) {
      case k_run: run(); b = 0; break;		/* RUN key */
      case k_ret:        b = 0; break;	 	/* RET key */
      case k_as: if(last != k_as) set_adr();	/* ADRS SET key */
                 else assembler();			/* double ADRS SET key */
                 last = -1; break;
      case k_rdd: if((addrreg == regpc) &&	/* READ DECR key */
                     (datareg == regpsw)) {	/* break point mode */
                    addrreg = &brkcnt;
                    rd_mem();
                  } else rd_dec();		/* memory read & address decremant */
                  break;
      case k_rdi: if((addrreg == regpc) &&	/* READ INCR key */
                     (datareg == regpsw)) {	/* break point mode */
                    addrreg = &reghl;
                    rd_mem();
                  } else rd_inc();		/* memory read & address increment */
                  break;
      case k_wri: wr_inc();  break;		/* WRITE INCR key */
      case k_sd: st_tape(); break;		/* STORE DATA key */
      case k_ld: if(ld_tape()) error();		/* LOAD DATA key */
                 break;
      default: sft_data(k & 0x0f); break;	/* 0-F key */
    }
    last = k;
    adr_data();
  }
}

/********************************************************
 * Check CPU and Clock Frequency			*
 ********************************************************/

char seg80[] = { led8, led0l, led8, led0l, led2p, led0l, led_, led1 }; /* "8080 2.0-1" */
char seg85[] = { led8, led0l, led8, led5,  led2p, led0l, 0x00, 0x00 }; /* "8085 2.0  " */

dsp_cpu()	/* display cpu clock frequency */
{ int n;
  outppc(0x01);	/* enable CMT modulator */
  n = clock();
  if(n != 0) {		/* measured 4 cycles time vales of CMT modulator */
    if(i8085()) {		/* 8085 CPU */
      memcpy(&dig1, seg85, 8);	/* copy "8085 2.0  " to segment memory */
      if(n < 0x62) { 		/* 8085 2MHz */
        n = d85_2m;	/* set 125uS timer address */
      } else if(n < 0x8b) {	/* 8085 3MHz */
        n = d85_3m;	/* set 125uS timer address */
        dig5 = led3p;		/* display "8085 3.0  " */
      } else if(n < 0xb3) {	/* 8085 4MHz */
        n = d85_4m;	/* set 125uS timer address */
        dig5 = led4p;		/* display "8085 4.0  " */
      } else {			/* 8085 5MHz */
        n = d85_5m;	/* set 125uS timer address */
        dig5 = led5p;		/* display "8085 5.0  " */
      }
    } else {			/* 8080 CPU */
      memcpy(&dig1, seg80, 8);	/* copy "8080 2.0-1" to segment memory */
      if(n < 0x42) {		/* 8080 2MHz 1wait */
        n = d80_1w;	/* set 125uS timer address */
      } else if(n < 0x5d) {	/* 8080 2MHz 0wait */
        n = d80_0w;	/* set 125uS timer address */
        dig8 = led0l;		/* display "8080 2.0-0" */
      } else { 			/* 8080 3MHz */
        n = d80_3m;	/* set 125uS timer address */
        dig5 = led3p;
        dig78 = 0;		/* display "8080 3.0  " */
      }
    }
    if(t125us != n) {		/* cold start ? */
      t125us = n;
      outppc(0x80);		/* enable LED display */
      delay(111);		/* wait for 3 sec */
    }
  } else t125us = d80_0w;	/* unable to sense CPU clock */
}

/********************************************************
 * Assembler Processor					*
 *  format(1): <opcode><sp>				*
 *  format(2): <opcode><sp><register operand>		*
 *  format(3): <opcode><sp><data address perand><sp>	*
 ********************************************************/

#define	dd	1	/* 8 bit data */
#define	rp_dddd	2	/* regiter pair, 16 bit data */
#define	ddd_dd	3	/* distination register, 8 bit data */
#define	dddd	4	/* 16 bit data */
#define	aaaa	5	/* 16 bit address */
#define	sss	6	/* source register */
#define	ddd	7	/* destination register */
#define	ddd_sss	8	/* source, distination register */
#define	rp	9	/* register pair */
#define	rps	9	/* register pair for PUSH/POP */
#define	bd	10	/* B or D register */
#define	num	11	/* 0-7 number */
#define	none	12	/* no parameter */
#define	fill	13	/* fill command */
#define	move	14	/* move command */

/* hash = 0 */
#asm
HASH0:
#endasm
char opnop[] =   {0x00, none,   k_n+1, k_o+1, k_p+1, 0};
char opsbb[] =   {0x98, sss,    k_s+1, k_b+1, k_b+1, 0};
char opsui[] =   {0xd6, dd,     k_s+1, k_u+1, k_i+1, 0};

/* hash = 1 */
#asm
HASH1:
#endasm
char opcpi[] =   {0xfe, dd,     k_c+1, k_p+1, k_i+1, 0};
char opdaa[] =   {0x27, none,   k_d+1, k_a+1, k_a+1, 0};
char oprnz[] =   {0xc0, none,   k_r+1, k_n+1, k_z+1, 0};
char opstc[] =   {0x37, none,   k_s+1, k_t+1, k_c+1, 0};
char opxra[] =   {0xa8, sss,    k_x+1, k_r+1, k_a+1, 0};

/* hash = 2 */
#asm
HASH2:
#endasm
char opdcr[]  =  {0x05, ddd,    k_d+1, k_c+1, k_r+1, 0};
char opret[]  =  {0xc9, none,   k_r+1, k_e+1, k_t+1, 0};
char opsphl[] =  {0xf9, none,   k_s+1, k_p+1, k_h+1, k_l+1, 0};

/* hash = 3 */
#asm
HASH3:
#endasm
char opadc[] =   {0x88, sss,    k_a+1, k_d+1, k_c+1, 0};
char oprpo[] =   {0xe0, none,   k_r+1, k_p+1, k_o+1, 0};

/* hash = 4 */
#asm
HASH4:
#endasm
char opadd[]  =  {0x80, sss,    k_a+1, k_d+1, k_d+1, 0};
char opcmp[]  =  {0xb8, sss,    k_c+1, k_m+1, k_p+1, 0};
char opcnz[]  =  {0xc4, aaaa,   k_c+1, k_n+1, k_z+1, 0};
char opdad[]  =  {0x09, rp,     k_d+1, k_a+1, k_d+1, 0};
char opjpe[]  =  {0xea, aaaa,   k_j+1, k_p+1, k_e+1, 0};
char oppchl[] =  {0xe9, none,   k_p+1, k_c+1, k_h+1, k_l+1, 0};

/* hash = 6 */
#asm
HASH6:
#endasm
char opcpo[]  =  {0xe4, aaaa,   k_c+1, k_p+1, k_o+1, 0};
char opout[]  =  {0xd3, dd,     k_o+1, k_u+1, k_t+1, 0};
char opmove[] =  {0x00, move,   k_m+1, k_o+1, k_v+1, k_e+1, 0};

/* hash = 7 */
#asm
HASH7:
#endasm
char opdcx[] =   {0x0b, rp,     k_d+1, k_c+1, k_x+1, 0};

/* hash = 8 */
#asm
HASH8:
#endasm
char opin[] =    {0xdb, dd,     k_i+1, k_n+1, 0};
char opjm[] =    {0xfa, aaaa,   k_j+1, k_m+1, 0};

/* hash = 9 */
#asm
HASH9:
#endasm
char opldax[] =  {0x0a, bd,     k_l+1, k_d+1, k_a+1, k_x+1, 0};
char opsub[]  =  {0x90, sss,    k_s+1, k_u+1, k_b+1, 0};

/* hash = 10 */
#asm
HASH10:
#endasm
char oprpe[] =   {0xe8, none,   k_r+1, k_p+1, k_e+1, 0};

/* hash = 13 */
#asm
HASH13:
#endasm
char opcpe[]  =  {0xec, aaaa,   k_c+1, k_p+1, k_e+1, 0};
char oppop[]  =  {0xc1, rp,     k_p+1, k_o+1, k_p+1, 0};
char opstax[] =  {0x02, bd,     k_s+1, k_t+1, k_a+1, k_x+1, 0};

/* hash = 14 */
#asm
HASH14:
#endasm
char oprm[] =    {0xf8, none,   k_r+1, k_m+1, 0};

/* hash = 15 */
#asm
HASH15:
#endasm
char opdi[] =    {0xf3, none,   k_d+1, k_i+1, 0};
char opjc[] =    {0xda, aaaa,   k_j+1, k_c+1, 0};

/* hash = 16 */
#asm
HASH16:
#endasm
char opei[]  =   {0xfb, none,   k_e+1, k_i+1, 0};
char ophlt[] =   {0x76, none,   k_h+1, k_l+1, k_t+1, 0};
char oprim[] =   {0x20, none,   k_r+1, k_i+1, k_m+1, 0};

/* hash = 17 */
#asm
HASH17:
#endasm
char opcm[]  =   {0xfc, aaaa,   k_c+1, k_m+1, 0};
char opinr[] =   {0x04, ddd,    k_i+1, k_n+1, k_r+1, 0};
char opsim[] =   {0x30, none,   k_s+1, k_i+1, k_m+1, 0};

/* hash = 18 */
#asm
HASH18:
#endasm
char opani[]  =  {0xe6, dd,     k_a+1, k_n+1, k_i+1, 0};
char opori[]  =  {0xf6, dd,     k_o+1, k_r+1, k_i+1, 0};
char oppush[] =  {0xc5, rp,     k_p+1, k_u+1, k_s+1, k_h+1, 0};

/* hash = 19 */
#asm
HASH19:
#endasm
char opmvi[] =   {0x06, ddd_dd, k_m+1, k_v+1, k_i+1, 0};

/* hash = 20 */
#asm
HASH20:
#endasm
char oplxi[] =   {0x01, rp_dddd,k_l+1, k_x+1, k_i+1, 0};

/* hash = 21 */
#asm
HASH21:
#endasm
char opjnc[] =   {0xd2, aaaa,   k_j+1, k_n+1, k_c+1, 0};
char opjz[]  =   {0xca, aaaa,   k_j+1, k_z+1, 0};
char oprc[]  =   {0xd8, none,   k_r+1, k_c+1, 0};

/* hash = 22 */
#asm
HASH22:
#endasm
char opinx[]  =  {0x03, rp,     k_i+1, k_n+1, k_x+1, 0};
char opjp[]   =  {0xf2, aaaa,   k_j+1, k_p+1, 0};
char oplhld[] =  {0x2a, aaaa,   k_l+1, k_h+1, k_l+1, k_d+1, 0};

/* hash = 23 */
#asm
HASH23:
#endasm
char opral[] =   {0x17, none,   k_r+1, k_a+1, k_l+1, 0};
char opsbi[] =   {0xde, dd,     k_s+1, k_b+1, k_i+1, 0};

/* hash = 24 */
#asm
HASH24:
#endasm
char opaci[] =   {0xce, dd,     k_a+1, k_c+1, k_i+1, 0};
char opcc[]  =   {0xdc, aaaa,   k_c+1, k_c+1, 0};
char opmov[] =   {0x40, ddd_sss,k_m+1, k_o+1, k_v+1, 0};

/* hash = 25 */
#asm
HASH25:
#endasm
char opadi[]  =  {0xc6, dd,     k_a+1, k_d+1, k_i+1, 0};
char oprlc[]  =  {0x07, none,   k_r+1, k_l+1, k_c+1, 0};
char opxri[]  =  {0xee, dd,     k_x+1, k_r+1, k_i+1, 0};
char opfill[] =  {0x00, fill,   k_f+1, k_i+1, k_l+1, k_l+1, 0};

/* hash = 26 */
#asm
HASH26:
#endasm
char opana[] =   {0xa0, sss,    k_a+1, k_n+1, k_a+1, 0};
char opora[] =   {0xb0, sss,    k_o+1, k_r+1, k_a+1, 0};

/* hash = 27 */
#asm
HASH27:
#endasm
char opcma[]  =  {0x2f, none,   k_c+1, k_m+1, k_a+1, 0};
char opjmp[]  =  {0xc3, aaaa,   k_j+1, k_m+1, k_p+1, 0};
char opjnz[]  =  {0xc2, aaaa,   k_j+1, k_n+1, k_z+1, 0};
char oplda[]  =  {0x3a, aaaa,   k_l+1, k_d+1, k_a+1, 0};
char oprnc[]  =  {0xd0, none,   k_r+1, k_n+1, k_c+1, 0};
char oprz[]   =  {0xc8, none,   k_r+1, k_z+1, 0};
char opxchg[] =  {0xeb, none,   k_x+1, k_c+1, k_h+1, k_g+1, 0};

/* hash = 28 */
#asm
HASH28:
#endasm
char oprar[]  =  {0x1f, none,   k_r+1, k_a+1, k_r+1, 0};
char oprp[]   =  {0xf0, none,   k_r+1, k_p+1, 0};
char opshld[] =  {0x22, aaaa,   k_s+1, k_h+1, k_l+1, k_d+1, 0};

/* hash = 29 */
#asm
HASH29:
#endasm
char opcmc[] =   {0x3f, none,   k_c+1, k_m+1, k_c+1, 0};
char opjpo[] =   {0xe2, aaaa,   k_j+1, k_p+1, k_o+1, 0};

/* hash = 30 */
#asm
HASH30:
#endasm
char opcall[] =  {0xcd, aaaa,   k_c+1, k_a+1, k_l+1, k_l+1, 0};
char opcnc[]  =  {0xd4, aaaa,   k_c+1, k_n+1, k_c+1, 0};
char opcz[]   =  {0xcc, aaaa,   k_c+1, k_z+1, 0};
char oprrc[]  =  {0x0f, none,   k_r+1, k_r+1, k_c+1, 0};
char oprst[]  =  {0xc7, num,    k_r+1, k_s+1, k_t+1, 0};
char opxthl[] =  {0xe3, none,   k_x+1, k_t+1, k_h+1, k_l+1, 0};

/* hash = 31 */
#asm
HASH31:
#endasm
char opcp[]  =   {0xf4, aaaa,   k_c+1, k_p+1, 0};
char opsta[] =   {0x32, aaaa,   k_s+1, k_t+1, k_a+1, 0};

/* int htable[32] = {opnop, opcpi,  opdcr, opadc, opadd, 0,     opcpo,  opdcx,
		     opin,  opldax, oprpe, 0,     0,     opcpe, oprm,   opdi,
		     opei,  opcm,   opani, opmvi, oplxi, opjnc, opinx,  opral,
		     opaci, opadi,  opana, opcma, oprar, opcmc, opcall, opcp}; */

int htable[32];

#asm
	ORG	$-64
	DW	HASH0,  HASH1,  HASH2,  HASH3,  HASH4,  0,      HASH6,  HASH7
	DW	HASH8,  HASH9,  HASH10, 0,      0,      HASH13, HASH14, HASH15
	DW	HASH16, HASH17, HASH18, HASH19, HASH20, HASH21, HASH22, HASH23
	DW	HASH24, HASH25, HASH26, HASH27, HASH28, HASH29, HASH30, HASH31
#endasm

char htlen[] = {3, 5, 3, 2, 6, 0, 3, 1,
                2, 2, 1, 0, 0, 3, 1, 2,
                3, 3, 3, 1, 1, 3, 3, 2,
                3, 4, 2, 7, 3, 2, 6, 2};

char regs()	/* 8 bit registers */
{
  switch(key_in()) {
    case k_a: return 0x07; 	/* A register */
    case k_b: return 0x00;	/* B register */
    case k_c: return 0x01;	/* C register */
    case k_d: return 0x02;	/* D register */
    case k_e: return 0x03;	/* E register */
    case k_h: return 0x04;	/* H register */
    case k_l: return 0x05;	/* L register */
    default: return 0xff;
  }
}

char regp()	/* 16 bit register pairs */
{
  switch(key_in()) {
    case k_b: return 0x00;	/* B register pair */
    case k_d: return 0x01;	/* D register pair */
    case k_h: return 0x02;	/* H register pair */
    case k_s: return 0x03;	/* SP register pair */
    default: return 0xff;
  }
}

char regps()	/* 16 bit register pairs for PUSH/POP */
{
  switch(key_in()) {
    case k_b: return 0x00;	/* B register pair */
    case k_d: return 0x01;	/* D register pair */
    case k_h: return 0x02;	/* H register pair */
    case k_p: return 0x03;	/* PSW register pair */
    default: return 0xff;
  }
}

char regbd()
{
  switch(key_in()) {
    case k_b: return 0x00;	/* B register pair */
    case k_d: return 0x01;	/* D register pair */
    default: return 0xff;
  }
}

char hex_in()
{ char k;
  datareg = 0;
  while(1) {
    dig3 |= 0x80;			/* operand prompt */
    if((k = key_in()) & 0x0f0) break;
    sft_data(k); dsp_reg();	/* 0-F key */
  }
  return k;
}

char adr_in()
{ char k;
  if((k = key_in()) == k_rdi || k == k_rdd) {	/* if k_rdi or k_rdd, relative address */
    datareg = addrreg - 1;
    while(1) {
      if(k == k_rdi) datareg++;
      else if(k == k_rdd) datareg--;
      else break;
      dsp_reg();
      dig3 |= 0x80; 		/* operand prompt */
      k = key_in();
    }
  } else {
    datareg = 0;
    while(1) {
      if(k & 0x0f0) break;
      sft_data(k); dsp_reg();	/* 0-F key */
      dig3 |= 0x80;		/* operand prompt */
      k = key_in();
    }
  }
  return k;
}

void assembler()	/* simple 8080/8085 Asembler */
{ char h, n, k, i, err;
  char opcode, oprand;
  char op[6];
  char *ht, *p;
  int s;
  while(1) {
    h = 0;
    dig4 |= 0x80; 		/* opcode prompt */
    dig3 &= 0x7f; 		/* opcode prompt */
    for(i = 0; i < 5; i++) {	/* input opcode terminated by k_sp key */
    if((k = key_in()) == k_sp) break;
      h += k;			/* calculate hash value */
      op[i] = k + 1;
    }
    op[i] = 0;		/* terminate opcode string */
    err = 1;		/* set err flag */
    if(!h) break;	/* no opcode */
    h &= 0x1f;		/* lower 5 bit of remainder */
    ht = htable[h];	/* search opcode in hash table */
    n = htlen[h];
    oprand = 0;
    if (ht) for(i = 0; i < n; i++) {
      opcode = *ht++;	/* set copcde value */
      oprand = *ht++;	/* set oprand type */
      if(strcmp(op, ht)) {	/* unmatch opcode string */
        ht += strlen(ht) + 1;	/* next pointer */
        oprand = 0;		/* discard oprand type */
      } else break;		/* hit opcode string */
    }
    if(oprand) {		/* valid opcode */
      p = addrreg - 1; data_h = *p++;
      data_l = opcode;
      dsp_reg();
      dig3 |= 0x80; 		/* operand prompt */
      switch(oprand) {
        case dd:			/* 8 bit data */
          *p = data_l;
          if(hex_in() != k_sp) break;
          addrreg++; p = addrreg++; *p = data_l;
          err = 0; break;
        case ddd_dd:			/* distination register and 8 bit data */
          if((k = regs()) < 0) break;
          data_l += (k << 3);
          dsp_reg();
          *p = data_l;
          if(hex_in() != k_sp) break;
          addrreg++; p = addrreg++; *p = data_l;
          err = 0; break;
        case dddd:			/* 16 bit data */
          *p = data_l;
          if(hex_in() != k_sp) break;
          addrreg++; p = addrreg++; *p = data_l;
          p = addrreg++; *p = data_h;
          err = 0; break;
        case rp_dddd:			/* register pair and 16 bit data */
          if((k = regp()) < 0) break;
          data_l += (k << 4);
          dsp_reg();
          *p = data_l;
          if(hex_in() != k_sp) break;
          addrreg++; p = addrreg++; *p = data_l;
          p = addrreg++; *p = data_h;
          err = 0; break;
        case aaaa:			/* 16 bit address */
          *p = data_l;
          if(adr_in() != k_sp) break;
          addrreg++; p = addrreg++; *p = data_l;
          p = addrreg++; *p = data_h;
          err = 0; break;
        case sss:			/* source register */
          if((k = regs()) < 0) break;
          data_l += k;
          dsp_reg();
          *p = data_l; addrreg++; 
          err = 0; break;
        case ddd:			/* destination register */
          if((k = regs()) < 0) break;
          data_l += (k << 3);
          dsp_reg();
          *p = data_l; addrreg++; 
          err = 0; break;
        case ddd_sss:			/* source, distination register */
          if((k = regs()) < 0) break;
          data_l += k;
          dsp_reg();
          if((k = regs()) < 0) break;
          data_l += (k << 3);
          dsp_reg();
          *p = data_l; addrreg++; 
          err = 0; break;
        case rp:			/* register pair */
          if((k = regp()) < 0) break;
          data_l += (k << 4);
          dsp_reg();
          *p = data_l; addrreg++; 
          err = 0; break;
        case bd:			/* B or D register */
          if((k = regbd()) < 0) break;
          data_l += (k << 4);
          dsp_reg();
          *p = data_l; addrreg++; 
          err = 0; break;
        case num:			/* 0-7 number */
          if((k = key_in()) <0 || k >7) break;
          data_l += (k << 3);
          dsp_reg();
          *p = data_l; addrreg++; 
          err = 0; break;
        case none:			/* no parameter */
          *p = data_l; addrreg++; 
          err = 0; break;
        case fill:			/* fill command */
          if(hex_in() != k_sp) break;	/* data byte */
          s = datareg;
          if(hex_in() != k_sp) break;	/* data length */
          memset(addrreg, s, datareg);	/* fill byte into addrreg area */
          addrreg += datareg;
          err = 0; break;
        case move:			/* move command */
          if(adr_in() != k_sp) break;	/* source address */
          s = datareg;
          if(hex_in() != k_sp) break;	/* source length */
          memcpy(addrreg, s, datareg);	/* move data into addrreg area */
          addrreg += datareg;
          err = 0; break;
        default: break;
      }
    }
    if(err) {
      error2();		/* display error */
      delay(37);	/* wait for 1 sec */
    }
  }
}


